# mypy-boto3-service-quotas

[![PyPI - mypy-boto3-service-quotas](https://img.shields.io/pypi/v/mypy-boto3-service-quotas.svg?color=blue)](https://pypi.org/project/mypy-boto3-service-quotas)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-service-quotas.svg?color=blue)](https://pypi.org/project/mypy-boto3-service-quotas)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

- [mypy-boto3-service-quotas](#mypy-boto3-service-quotas)
  - [How to use](#how-to-use)
  - [Automated type discovery](#automated-type-discovery)


Type annotations for
[boto3.ServiceQuotas 1.13.26](https://boto3.amazonaws.com/v1/documentation/api/1.13.26/reference/services/service-quotas.html#ServiceQuotas) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 2.0.3](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

- [mypy-boto3-service-quotas](#mypy-boto3-service-quotas)
  - [How to use](#how-to-use)
    - [Type checking](#type-checking)
  - [How it works](#how-it-works)

## How to use

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `ServiceQuotas` service.

```bash
python -m pip install boto3-stubs[service-quotas]

# update installed packages index for automated type discovery
python -m mypy_boto3
```

Use `boto3` with `mypy_boto3_service_quotas` in your project and enjoy type checking and auto-complete.

```python
import boto3

from mypy_boto3_service_quotas import ServiceQuotasClient

# Now mypy can check if your code is valid.
client: ServiceQuotasClient = boto3.client("service-quotas")

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: ServiceQuotasClient = session.client("service-quotas")



# Annotated paginators are included as well

import mypy_boto3_service_quotas.paginator as service_quotas_paginators

list_aws_default_service_quotas_paginator: service_quotas_paginators.ListAWSDefaultServiceQuotasPaginator = client.get_paginator("list_aws_default_service_quotas")
list_requested_service_quota_change_history_paginator: service_quotas_paginators.ListRequestedServiceQuotaChangeHistoryPaginator = client.get_paginator("list_requested_service_quota_change_history")
list_requested_service_quota_change_history_by_quota_paginator: service_quotas_paginators.ListRequestedServiceQuotaChangeHistoryByQuotaPaginator = client.get_paginator("list_requested_service_quota_change_history_by_quota")
list_service_quota_increase_requests_in_template_paginator: service_quotas_paginators.ListServiceQuotaIncreaseRequestsInTemplatePaginator = client.get_paginator("list_service_quota_increase_requests_in_template")
list_service_quotas_paginator: service_quotas_paginators.ListServiceQuotasPaginator = client.get_paginator("list_service_quotas")
list_services_paginator: service_quotas_paginators.ListServicesPaginator = client.get_paginator("list_services")
```

## Automated type discovery

`mypy_boto3` package can generate index for `mypy_boto3_service_quotas` and other installed services.

```bash
# Run this command when you add or remove service packages
python -m mypy_boto3
```

Generated index provides overloads for `boto3.client` and `boto3.service`,
`boto3.Session.client` and `boto3.Session.resource` functions,
so explicit type annotations are not needed.

- `mypy` supports function overloads as expected
- `PyCharm` also supports function overloads, but consumes a lot of RAM, use carefully
- `VSCode` does not currently support function overloads

Also, generated index allows you to import types from `mypy_boto3`:

```python
# you can replace imports
import mypy_boto3_service_quotas as service_quotas
from mypy_boto3_service_quotas import ServiceQuotasClient

# with these
from mypy_boto3 import service_quotas
from mypy_boto3.service_quotas import ServiceQuotasClient
```